--- old/usr/src/uts/common/os/semaphore.c	Tue Aug  7 13:15:15 2018
+++ new/usr/src/uts/common/os/semaphore.c	Tue Aug  7 13:15:15 2018
@@ -24,7 +24,9 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
+/*
+ * Copyright 2018 Nexenta Systems, Inc. All rights reserved.
+ */
 
 /*
  * This file contains the semaphore operations.
@@ -227,15 +229,15 @@
 	sema_impl_t	*s;
 	disp_lock_t	*sqlp;
 
+	/* no-op during panic */
+	if (panicstr)
+		return;
+
 	s = (sema_impl_t *)sp;
 	sqlp = &SQHASH(s)->sq_lock;
 	disp_lock_enter(sqlp);
 	ASSERT(s->s_count >= 0);
 	while (s->s_count == 0) {
-		if (panicstr) {
-			disp_lock_exit(sqlp);
-			return;
-		}
 		thread_lock_high(curthread);
 		SEMA_BLOCK(s, sqlp);
 		thread_unlock_nopreempt(curthread);
@@ -333,13 +335,13 @@
 	kthread_t 	*sq, *tp;
 	disp_lock_t	*sqlp;
 
+	/* no-op during panic */
+	if (panicstr)
+		return;
+
 	s = (sema_impl_t *)sp;
 	sqlp = &SQHASH(s)->sq_lock;
 	disp_lock_enter(sqlp);
-	if (panicstr) {
-		disp_lock_exit(sqlp);
-		return;
-	}
 	s->s_count++;
 	sq = s->s_slpq;
 	if (sq != NULL) {
@@ -373,6 +375,10 @@
 
 	int	gotit = 0;
 
+	/* no-op during panic */
+	if (panicstr)
+		return (1);
+
 	s = (sema_impl_t *)sp;
 	sqh = SQHASH(s);
 	disp_lock_enter(&sqh->sq_lock);
@@ -389,10 +395,10 @@
 {
 	sema_impl_t	*s;
 
-
-	s = (sema_impl_t *)sp;
+	/* no-op during panic */
 	if (panicstr)
 		return (1);
-	else
-		return (s->s_count <= 0);
+
+	s = (sema_impl_t *)sp;
+	return (s->s_count <= 0);
 }
